您的位置:首页 > 其它

HDU 1025 Constructing Roads In JGShining's Kingdom(LIS nlogn)

2016-08-11 21:36 447 查看
Description

JGShining’s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they’re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don’t wanna build a road with other poor ones, and rich ones also can’t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities … And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.



In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^

Input

Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.

Output

For each test case, output the result in the form of sample.

You should tell JGShining what’s the maximal number of road(s) can be built.

Sample Input

2

1 2

2 1

3

1 2

2 3

3 1

Sample Output

Case 1:

My king, at most 1 road can be built.

Case 2:

My king, at most 2 roads can be built.

Hint

Huge input, scanf is recommended.

题意:河的两岸有不同的国家,一边是穷国,一边是富国,穷国和富国的村庄的标号是固定的,穷国要向富国进口资源,富国也很乐意给穷国,现在需要建桥,并且建的桥不能够有交叉。问最多可以建多少座桥。

题解:这道题其实是在求最长上升子序列里的元素个数

容易忽略的地方:存在一条以上的路时road为复数roads。

方法:上网百度了一下因为每一个点只有一个所以不用排序,输入的p,r 可以直接用数组标记,li[p] = r,也节省了时间。

这道题用了LIS+二分,其实二分时可以用函数 lower_bound

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
int li[500010],v[500010];//v[]代表最长上升子序列
int main()
{
int t=1,n,p,r,i,j,k,mid,s,e;
while(~scanf("%d",&n))
{
memset(v,0,sizeof(v));
for(i=1;i<=n;i++)
{
scanf("%d%d",&p,&r);
li[p]=r;
}
k=0;
for(i=1;i<=n;i++)
{
if(li[i]>v[k])//若在v[]中没有找到比li[i]更大的数,则v[]中的元素个数加一,li[i]排在v[]序列已有所有数的末尾
{
k++;
v[k]=li[i];
}
else
{//利用二分查找,在v[]中找到第一个比li[i]大的数
s=0;e=k;
while(s<=e)
{
mid=(s+e)/2;
if(li[i]>v[mid])
s=mid+1;
else e=mid-1;
}
v[s]=li[i];//找到后进行替换更新
}
}//这样就能得到一个最长上升子序列v[](v[]中元素的替换更新仅仅是为了能得到最长的上升子序列,并不像li[i]=r那样有对应关系,k也只是用来计数的,这里是我对自己有迷惑地方的注释,可以自行理解)
if(k==1) printf("Case %d:\nMy king, at most 1 road can be built.\n\n", t++);
else printf("Case %d:\nMy king, at most %d roads can be built.\n\n", t++, k); //k表示最长上升子序列里的元素总个数
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: